#include <iostream>
#include <vector>

using namespace std;

int main() {
  int n, m;
  cin >> n >> m;
  vector<int> H(m);  // Alle husenes posisjoner
  for (int i = 0; i < m; ++i) {
    cin >> H[i];
  }
  int a = 0, b = 1000000001;  // Intervallet svaret ligger i
  while (b - a > 1) {
    int g = (a + b) / 2 - 1;  // Midtpunkt for intervallet, denen sjekker vi
    int lastStop = -1000000001;  // Sett forrige busstopp langt nok unna.
    int numStops = 0;
    for (int i = 0; i < m; ++i) {
      if (H[i] - lastStop > g) {
	// Trenger nytt stopp, plasser lengst mulig bortenfor dette huset
	lastStop = H[i] + g;
	++numStops;
	if (numStops > n) break;  // Ingen vits aa fortsette - allerede for mange stopp
      }
    }
    if (numStops > n) {
      // Her vet vi at svaret er mer enn vi gjettet
      a = g+1;
    } else {
      // ... og vice versa.
      b = g+1;
    }
  }
  cout << a << endl;
  return 0;
}

